]> git.proxmox.com Git - rustc.git/blob - src/ci/run.sh
New upstream version 1.42.0+dfsg1
[rustc.git] / src / ci / run.sh
1 #!/usr/bin/env bash
2
3 set -e
4
5 if [ -n "$CI_JOB_NAME" ]; then
6 echo "[CI_JOB_NAME=$CI_JOB_NAME]"
7 fi
8
9 if [ "$NO_CHANGE_USER" = "" ]; then
10 if [ "$LOCAL_USER_ID" != "" ]; then
11 useradd --shell /bin/bash -u $LOCAL_USER_ID -o -c "" -m user
12 export HOME=/home/user
13 unset LOCAL_USER_ID
14 exec su --preserve-environment -c "env PATH=$PATH \"$0\"" user
15 fi
16 fi
17
18 # only enable core dump on Linux
19 if [ -f /proc/sys/kernel/core_pattern ]; then
20 ulimit -c unlimited
21 fi
22
23 ci_dir=`cd $(dirname $0) && pwd`
24 source "$ci_dir/shared.sh"
25
26 if ! isCI || isCiBranch auto || isCiBranch beta; then
27 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --set build.print-step-timings --enable-verbose-tests"
28 fi
29
30 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --enable-sccache"
31 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --disable-manage-submodules"
32 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --enable-locked-deps"
33 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --enable-cargo-native-static"
34 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --set rust.codegen-units-std=1"
35
36 if [ "$DIST_SRC" = "" ]; then
37 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --disable-dist-src"
38 fi
39
40 # If we're deploying artifacts then we set the release channel, otherwise if
41 # we're not deploying then we want to be sure to enable all assertions because
42 # we'll be running tests
43 #
44 # FIXME: need a scheme for changing this `nightly` value to `beta` and `stable`
45 # either automatically or manually.
46 export RUST_RELEASE_CHANNEL=stable
47
48 # Always set the release channel for bootstrap; this is normally not important (i.e., only dist
49 # builds would seem to matter) but in practice bootstrap wants to know whether we're targeting
50 # master, beta, or stable with a build to determine whether to run some checks (notably toolstate).
51 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --release-channel=$RUST_RELEASE_CHANNEL"
52
53 if [ "$DEPLOY$DEPLOY_ALT" = "1" ]; then
54 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --enable-llvm-static-stdcpp"
55 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --set rust.remap-debuginfo"
56 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --debuginfo-level-std=1"
57
58 if [ "$NO_LLVM_ASSERTIONS" = "1" ]; then
59 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --disable-llvm-assertions"
60 elif [ "$DEPLOY_ALT" != "" ]; then
61 if [ "$NO_PARALLEL_COMPILER" = "" ]; then
62 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --set rust.parallel-compiler"
63 fi
64 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --enable-llvm-assertions"
65 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --set rust.verify-llvm-ir"
66 fi
67 else
68 # We almost always want debug assertions enabled, but sometimes this takes too
69 # long for too little benefit, so we just turn them off.
70 if [ "$NO_DEBUG_ASSERTIONS" = "" ]; then
71 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --enable-debug-assertions"
72 fi
73
74 # In general we always want to run tests with LLVM assertions enabled, but not
75 # all platforms currently support that, so we have an option to disable.
76 if [ "$NO_LLVM_ASSERTIONS" = "" ]; then
77 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --enable-llvm-assertions"
78 fi
79
80 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --set rust.verify-llvm-ir"
81 fi
82
83 if [ "$RUST_RELEASE_CHANNEL" = "nightly" ] || [ "$DIST_REQUIRE_ALL_TOOLS" = "" ]; then
84 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --enable-missing-tools"
85 fi
86
87 # Print the date from the local machine and the date from an external source to
88 # check for clock drifts. An HTTP URL is used instead of HTTPS since on Azure
89 # Pipelines it happened that the certificates were marked as expired.
90 datecheck() {
91 echo "== clock drift check =="
92 echo -n " local time: "
93 date
94 echo -n " network time: "
95 curl -fs --head http://detectportal.firefox.com/success.txt | grep ^Date: \
96 | sed 's/Date: //g' || true
97 echo "== end clock drift check =="
98 }
99 datecheck
100 trap datecheck EXIT
101
102 # We've had problems in the past of shell scripts leaking fds into the sccache
103 # server (#48192) which causes Cargo to erroneously think that a build script
104 # hasn't finished yet. Try to solve that problem by starting a very long-lived
105 # sccache server at the start of the build, but no need to worry if this fails.
106 SCCACHE_IDLE_TIMEOUT=10800 sccache --start-server || true
107
108 if [ "$RUN_CHECK_WITH_PARALLEL_QUERIES" != "" ]; then
109 $SRC/configure --enable-parallel-compiler
110 CARGO_INCREMENTAL=0 python2.7 ../x.py check
111 rm -f config.toml
112 rm -rf build
113 fi
114
115 $SRC/configure $RUST_CONFIGURE_ARGS
116
117 retry make prepare
118
119 make check-bootstrap
120
121 # Display the CPU and memory information. This helps us know why the CI timing
122 # is fluctuating.
123 if isMacOS; then
124 system_profiler SPHardwareDataType || true
125 sysctl hw || true
126 ncpus=$(sysctl -n hw.ncpu)
127 else
128 cat /proc/cpuinfo || true
129 cat /proc/meminfo || true
130 ncpus=$(grep processor /proc/cpuinfo | wc -l)
131 fi
132
133 if [ ! -z "$SCRIPT" ]; then
134 sh -x -c "$SCRIPT"
135 else
136 do_make() {
137 echo "make -j $ncpus $1"
138 make -j $ncpus $1
139 local retval=$?
140 return $retval
141 }
142
143 do_make "$RUST_CHECK_TARGET"
144 fi
145
146 sccache --show-stats || true